config/routes.rb
require 'sidekiq/web'
require 'api/api'

Gitlab::Application.routes.draw do
  #
  # Search
  #
  get 'search' => "search#show"
  get 'search/autocomplete' => "search#autocomplete", as: :search_autocomplete
  get 'search/autocomplete2' => "search#autocomplete2", as: :search_autocomplete2

  # API
  API::API.logger Rails.logger
  mount API::API => '/api'

  # Get all keys of user
  get ':username.keys' => 'profiles/keys#get_keys' , constraints: { username: /.*/ }

  constraint = lambda { |request| request.env["warden"].authenticate? and request.env['warden'].user.admin? }
  constraints constraint do
    mount Sidekiq::Web, at: "/admin/sidekiq", as: :sidekiq
  end

  # Enable Grack support
  mount Grack::Bundle.new({
    git_path:     Gitlab.config.git.bin_path,
    project_root: Gitlab.config.gitlab_shell.repos_path,
    upload_pack:  Gitlab.config.gitlab_shell.upload_pack,
    receive_pack: Gitlab.config.gitlab_shell.receive_pack
  }), at: '/', constraints: lambda { |request| /[-\/\w\.]+\.git\//.match(request.path_info) }, via: [:get, :post]

  #
  # Help
  #

  get 'help'                  => 'help#index'
  get 'help/:category/:file'  => 'help#show', as: :help_page
  get 'help/shortcuts'


  #
  # Global snippets
  #
  resources :snippets do
    member do
      get "raw"
    end
  end
  get "/s/:username" => "snippets#user_index", as: :user_snippets, constraints: { username: /.*/ }

  #
  # Public namespace
  #
  namespace :public do
    resources :projects, only: [:index]
    root to: "projects#index"
  end

  #
  # Attachments serving
  #
  get 'files/:type/:id/:filename' => 'files#download', constraints: { id: /\d+/, type: /[a-z]+/, filename:  /.+/ }

  #
  # Admin Area
  #
  namespace :admin do
    resources :users, constraints: { id: /[a-zA-Z.\/0-9_\-]+/ } do
      member do
        put :team_update
        put :block
        put :unblock
      end
    end

    resources :groups, constraints: { id: /[^\/]+/ } do
      member do
        put :project_teams_update
      end
    end

    resources :hooks, only: [:index, :create, :destroy] do
      get :test
    end

    resources :broadcast_messages, only: [:index, :create, :destroy]
    resource :logs, only: [:show]
    resource :background_jobs, controller: 'background_jobs', only: [:show]

    resources :projects, constraints: { id: /[a-zA-Z.\/0-9_\-]+/ }, only: [:index, :show] do
      member do
        put :transfer
      end
    end

    root to: "dashboard#index"
  end

  #
  # Profile Area
  #
  resource :profile, only: [:show, :update] do
    member do
      get :history
      get :design

      put :reset_private_token
      put :update_username
    end

    scope module: :profiles do
      resource :account, only: [:show, :update]
      resource :notifications, only: [:show, :update]
      resource :password, only: [:new, :create, :edit, :update] do
        member do
          put :reset
        end
      end
      resources :keys
      resources :emails, only: [:index, :create, :destroy]
      resources :groups, only: [:index] do
        member do
          delete :leave
        end
      end
      resource :avatar, only: [:destroy]
    end
  end

  match "/u/:username" => "users#show", as: :user, constraints: { username: /.*/ }, via: :get

  #
  # Dashboard Area
  #
  resource :dashboard, controller: "dashboard", only: [:show] do
    member do
      get :projects
      get :issues
      get :merge_requests
    end
  end

  #
  # Groups Area
  #
  resources :groups, constraints: {id: /(?:[^.]|\.(?!atom$))+/, format: /atom/}  do
    member do
      get :issues
      get :merge_requests
      get :members
      get :projects
    end

    resources :users_groups, only: [:create, :update, :destroy]
    scope module: :groups do
      resource :avatar, only: [:destroy]
    end
  end

  #
  # Ideus Area
  #
  get 'tags/:tag', to: 'products#index', as: :tag
  get 'list_tags', to: 'products#tags'
  get 'list_ingredients', to: 'products#list_ingredients'
  get 'existing_tags', to: 'products#existing_tags'

  resources :products do
    collection do
      get     'search'
    end
    member do
      post    'favorite'
      delete  'remove_favorite'
      post    'copy'
    end
  end
  resources :companies
  resources :ingredients
  resources :nutrients
  resources :minerals
  resources :vitamins
  resources :brands
  resources :allergens, only: [:index, :create, :destroy]
  resources :recycling_symbols
  resources :certificate_symbols
  resources :locations
  resources :photos do
    member do
      delete :destroy_product
      delete :destroy_company
      delete :destroy_brand
      delete :destroy_recycling_symbol
      delete :destroy_certificate_symbol
    end
  end

  resources :projects, constraints: { id: /[^\/]+/ }, only: [:new, :create]

  devise_for :users, controllers: { omniauth_callbacks: :omniauth_callbacks, registrations: :registrations , passwords: :passwords}

  #
  # Project Area
  #
  resources :projects, constraints: { id: /[a-zA-Z.0-9_\-]+\/[a-zA-Z.0-9_\-]+/ }, except: [:new, :create, :index], path: "/" do
    member do
      put :transfer
      post :fork
      post :archive
      post :unarchive
      post :upload_image
      get :autocomplete_sources
      get :import
      put :retry_import
    end

    scope module: :projects do
      resources :blob,      only: [:show, :destroy], constraints: {id: /.+/}
      resources :raw,       only: [:show], constraints: {id: /.+/}
      resources :tree,      only: [:show], constraints: {id: /.+/, format: /(html|js)/ }
      resources :edit_tree, only: [:show, :update], constraints: { id: /.+/ }, path: 'edit' do
        post :preview, on: :member
      end
      resources :new_tree,  only: [:show, :update], constraints: {id: /.+/}, path: 'new'
      resources :commit,    only: [:show], constraints: {id: /[[:alnum:]]{6,40}/}
      resources :commits,   only: [:show], constraints: {id: /(?:[^.]|\.(?!atom$))+/, format: /atom/}
      resources :compare,   only: [:index, :create]
      resources :blame,     only: [:show], constraints: {id: /.+/}
      resources :network,   only: [:show], constraints: {id: /(?:[^.]|\.(?!json$))+/, format: /json/}
      resources :graphs,    only: [:show], constraints: {id: /(?:[^.]|\.(?!json$))+/, format: /json/}

      match "/compare/:from...:to" => "compare#show", as: "compare", via: [:get, :post], constraints: {from: /.+/, to: /.+/}

        resources :snippets, constraints: {id: /\d+/} do
          member do
            get "raw"
          end
        end

      resources :wikis, only: [:show, :edit, :destroy, :create], constraints: {id: /[a-zA-Z.0-9_\-\/]+/} do
        collection do
          get :pages
          put ':id' => 'wikis#update'
          get :git_access
        end

        member do
          get "history"
        end
      end

      resource :repository, only: [:show] do
        member do
          get "stats"
          get "archive", constraints: { format: Gitlab::Regex.archive_formats_regex }
        end
      end

      resources :services, constraints: { id: /[^\/]+/ }, only: [:index, :edit, :update] do
        member do
          get :test
        end
      end

      resources :deploy_keys, constraints: {id: /\d+/} do
        member do
          put :enable
          put :disable
        end
      end

      resources :branches, only: [:index, :new, :create, :destroy], constraints: { id: Gitlab::Regex.git_reference_regex }
      resources :tags, only: [:index, :new, :create, :destroy], constraints: { id: Gitlab::Regex.git_reference_regex }
      resources :protected_branches, only: [:index, :create, :destroy], constraints: { id: Gitlab::Regex.git_reference_regex }

      resources :refs, only: [] do
        collection do
          get "switch"
        end

        member do
          # tree viewer logs
          get "logs_tree", constraints: { id: Gitlab::Regex.git_reference_regex }
          get "logs_tree/:path" => "refs#logs_tree",
            as: :logs_file,
            constraints: {
              id:   Gitlab::Regex.git_reference_regex,
              path: /.*/
            }
        end
      end

      resources :merge_requests, constraints: {id: /\d+/}, except: [:destroy] do
        member do
          get :diffs
          post :automerge
          get :automerge_check
          get :ci_status
        end

        collection do
          get :branch_from
          get :branch_to
          get :update_branches
        end
      end

      resources :hooks, only: [:index, :create, :destroy], constraints: {id: /\d+/} do
        member do
          get :test
        end
      end

      resources :team, controller: 'team_members', only: [:index]
      resources :milestones, except: [:destroy], constraints: {id: /\d+/} do
        member do
          put :sort_issues
          put :sort_merge_requests
        end
      end

      resources :labels, only: [:index] do
        collection do
          post :generate
        end
      end

      resources :issues, constraints: {id: /\d+/}, except: [:destroy] do
        collection do
          post  :bulk_update
        end
      end

      resources :team_members, except: [:index, :edit], constraints: { id: /[a-zA-Z.\/0-9_\-#%+]+/ } do
        collection do
          delete :leave

          # Used for import team
          # from another project
          get :import
          post :apply_import
        end
      end

      resources :notes, only: [:index, :create, :destroy, :update], constraints: {id: /\d+/} do
        member do
          delete :delete_attachment
        end

        collection do
          post :preview
        end
      end
    end
  end

  get ':id' => "namespaces#show", constraints: {id: /(?:[^.]|\.(?!atom$))+/, format: /atom/}

  root to: "dashboard#show"
end

app/models/product.rb
class Product < ActiveRecord::Base
  is_impressionable
  include Searchable

  has_many :photos, as: :imageable, dependent: :destroy
  has_many :manufacture_companies
  has_many :manufacturers, :through => :manufacture_companies, :source => :company
  has_many :distribution_companies
  has_many :distributors, :through => :distribution_companies, :source => :company
  has_many :product_ingredients
  has_many :ingredients, :through => :product_ingredients
  has_many :product_allergens
  has_many :allergens, :through => :product_allergens
  has_many :product_nutrients
  has_many :nutrients, :through => :product_nutrients
  has_many :product_vitamins
  has_many :vitamins, :through => :product_vitamins
  has_many :product_minerals
  has_many :minerals, :through => :product_minerals

  has_many :users, :through => :favorites
  has_many :favorites
  belongs_to :brand

  has_many :product_rsymbols
  has_many :recycling_symbols, :through => :product_rsymbols
  has_many :product_csymbols
  has_many :certificate_symbols, :through => :product_csymbols

  accepts_nested_attributes_for :photos, :product_nutrients, :product_ingredients, :product_allergens, :product_vitamins, :product_minerals,
                                          :manufacture_companies, :distribution_companies,
                                          :product_rsymbols,
                                          allow_destroy: true

  attr_accessor :brand_name
  attr_accessor :ac_ingredient_ids
  attr_accessor :allergen_ingredient_ids
  attr_accessor :rsymbols
  attr_accessible :tag_list
  acts_as_taggable

  validates :name, :presence => true
  validates :description, :presence => true
  validates :barcode, format: { with: /\A([0-9]{8}|[0-9]{13})\Z/, message: "must be 13 or 8 digits"}, uniqueness: {message: "Barcode must be unique and can't be blank. "}, unless: :c_prod?

  def unsafe_for(user)
    return false if unsafe_ingredients_for(user).empty?
    return true
  end

  def unsafe_ingredients_for(user)
    product_ingredients.with_allergens(user.ingredient_ids)
  end

  def ac_ingredient_ids
    ingredient_ids.join(",")
  end

  def ac_ingredient_ids=(ids)
    product_ingredients.clear
    ids.split(",").select(&:present?).map do |ingredient_id|
      product_ingredients.build({ingredient_id: ingredient_id}, without_protection: true)
    end
  end

  def allergen_ingredient_ids
    ingredient_ids.join(",")
  end

  def allergen_ingredient_ids=(ids)
    product_allergens.clear
    ids.split(",").select(&:present?).map do |ingredient_id|
      product_allergens.build({ingredient_id: ingredient_id}, without_protection: true)
    end
  end

  def brand_name
    brand.try(:name)
  end

  def brand_name=(name)
    self.brand = Brand.find_by(name: name) if name.present?
  end

  def rsymbols
    recycling_symbol_ids.join(",")
  end

  def rsymbols=(ids)
    product_rsymbols.clear
    ids.split(",").select(&:present?).map do |recycling_symbol_id|
      product_rsymbols.build({recycling_symbol_id: recycling_symbol_id}, without_protection: true)
    end
  end

  def csymbols
    certificate_symbol_ids.join(",")
  end

  def csymbols=(ids)
    product_csymbols.clear
    ids.split(",").select(&:present?).map do |certificate_symbol_id|
      product_csymbols.build({certificate_symbol_id: certificate_symbol_id}, without_protection: true)
    end
  end
end

app/controllers/admin/groups_controller.rb
class Admin::GroupsController < Admin::ApplicationController
  before_filter :group, only: [:edit, :show, :update, :destroy, :project_update, :project_teams_update]

  def index
    @groups = Group.order('name ASC')
    @groups = @groups.search(params[:name]) if params[:name].present?
    @groups = @groups.page(params[:page]).per(20)
  end

  def show
    @members = @group.members.order("group_access DESC").page(params[:members_page]).per(30)
    @projects = @group.projects.page(params[:projects_page]).per(30)
  end

  def new
    @group = Group.new
  end

  def edit
  end

  def create
    @group = Group.new(params[:group])
    @group.path = @group.name.dup.parameterize if @group.name

    if @group.save
      @group.add_owner(current_user)
      redirect_to [:admin, @group], notice: 'Group was successfully created.'
    else
      render "new"
    end
  end

  def update
    if @group.update_attributes(params[:group])
      redirect_to [:admin, @group], notice: 'Group was successfully updated.'
    else
      render "edit"
    end
  end

  def project_teams_update
    @group.add_users(params[:user_ids].split(','), params[:group_access])

    redirect_to [:admin, @group], notice: 'Users were successfully added.'
  end

  def destroy
    @group.destroy

    redirect_to admin_groups_path, notice: 'Group was successfully deleted.'
  end

  private

  def group
    @group = Group.find_by(path: params[:id])
  end
end

app/controllers/groups/avatars_controller.rb
class Groups::AvatarsController < ApplicationController
  layout "profile"

  def destroy
    @group = Group.find_by(path: params[:group_id])
    @group.remove_avatar!

    @group.save

    redirect_to edit_group_path(@group)
  end
end

app/controllers/profiles/groups_controller.rb
class Profiles::GroupsController < ApplicationController
  layout "profile"

  def index
    @user_groups = current_user.users_groups.page(params[:page]).per(20)
  end

  def leave
    @users_group = group.users_groups.where(user_id: current_user.id).first
    if can?(current_user, :destroy, @users_group)
      @users_group.destroy
      redirect_to(profile_groups_path, info: "You left #{group.name} group.")
    else
      return render_403
    end
  end

  private

  def group
    @group ||= Group.find_by(path: params[:id])
  end
end

app/helpers/groups_helper.rb
module GroupsHelper
  def remove_user_from_group_message(group, user)
    "Are you sure you want to remove \"#{user.name}\" from \"#{group.name}\"?"
  end

  def leave_group_message(group)
    "Are you sure you want to leave \"#{group}\" group?"
  end
  
  def should_user_see_group_roles?(user, group)
    if user
      user.is_admin? || group.members.exists?(user_id: user.id)
    else
      false
    end
  end

  def group_head_title
    title = @group.name

    title = if current_action?(:issues)
              "Issues - " + title
            elsif current_action?(:merge_requests)
              "Merge requests - " + title
            elsif current_action?(:members)
              "Members - " + title
            elsif current_action?(:edit)
              "Settings - " + title
            else
              title
            end

    title

  end
end

app/views/groups/_filter.html.haml
= form_tag group_filter_path(entity), method: 'get' do
  %fieldset
    %ul.nav.nav-pills.nav-stacked
      %li{class: ("active" if !params[:status])}
        = link_to group_filter_path(entity, status: nil) do
          = t("groups.open")
      %li{class: ("active" if params[:status] == 'closed')}
        = link_to group_filter_path(entity, status: 'closed') do
          = t("groups.closed")
      %li{class: ("active" if params[:status] == 'all')}
        = link_to group_filter_path(entity, status: 'all') do
          = t("groups.all")

  %fieldset
    %legend= t('groups.projects') + ":"
    %ul.nav.nav-pills.nav-stacked
      - @projects.each do |project|
        - unless entities_per_project(project, entity).zero?
          %li{class: ("active" if params[:project_id] == project.id.to_s)}
            = link_to group_filter_path(entity, project_id: project.id) do
              = project.name_with_namespace
              %small.pull-right= entities_per_project(project, entity)
      - if @projects.blank?
        .nothing-here-block= t("groups.this_group_has_no_projects")

  %fieldset
    %hr
    = link_to t('groups.reset'), group_filter_path(entity), class: 'btn pull-right'

app/views/groups/_new_group_member.html.haml
= form_for @users_group, url: group_users_groups_path(@group), html: { class: 'form-horizontal users-group-form' } do |f|
  .form-group
    = f.label :user_ids, t("groups.people"), class: 'control-label'
    .col-sm-10= users_select_tag(:user_ids, multiple: true, class: 'input-large')

  .form-group
    = f.label :group_access, t("groups.group_access"), class: 'control-label'
    .col-sm-10= select_tag :group_access, options_for_select(UsersGroup.group_access_roles, @users_group.group_access), class: "project-access-select select2"

  .form-actions
    = f.submit t("groups.add_user_into_group"), class: "btn btn-create"

app/views/groups/_projects.html.haml
.panel.panel-default
  .panel-heading
    = "#{t('groups.projects')} (#{projects.count})"
    - if can? current_user, :create_projects, @group
      .panel-head-actions
        = link_to new_project_path(namespace_id: @group.id), class: "btn btn-new" do
          %i.icon-plus
          = t("groups.new_project")
  %ul.well-list
    - if projects.blank?
      .nothing-here-block= t("groups.this_group_has_no_projects")
    - projects.each do |project|
      %li.project-row
        = link_to project_path(project), class: dom_class(project) do
          .dash-project-access-icon
            = visibility_level_icon(project.visibility_level)
          %span.str-truncated
            %span.project-name
              = project.name
          %span.arrow
            %i.icon-angle-right

app/views/groups/_settings_nav.html.haml
%ul.nav.nav-pills.nav-stacked.nav-stacked-menu
  = nav_link(path: 'groups#edit') do
    = link_to edit_group_path(@group) do
      %i.icon-edit
      = t("groups.group")
  = nav_link(path: 'groups#projects') do
    = link_to projects_group_path(@group) do
      %i.icon-folder-close
      = t("groups.projects")

app/views/groups/edit.html.haml
.row
  .col-md-2
    = render 'settings_nav'
  .col-md-10
    .panel.panel-default
      .panel-heading
        %strong= @group.name
        = t("groups.group_settings")
      .panel-body
        = form_for @group, html: { multipart: true, class: "form-horizontal" }, authenticity_token: true do |f|
          - if @group.errors.any?
            .alert.alert-danger
              %span= @group.errors.full_messages.first
          .form-group
            = f.label :name, class: 'control-label' do
              = t("groups.group_name")
            .col-sm-10
              = f.text_field :name, placeholder: t("groups.ex_opensource"), class: "form-control left"

          .form-group.group-description-holder
            = f.label :description, t("groups.details"), class: 'control-label'
            .col-sm-10
              = f.text_area :description, maxlength: 250, class: "form-control js-gfm-input", rows: 4

          .form-group
            .col-sm-2
            .col-sm-10
              = image_tag group_icon(@group.to_param), alt: '', class: 'avatar s160'
              %p.light
                - if @group.avatar?
                  = t("groups.you_can_change_your_group_avatar")
                - else
                  = t("groups.you_can_upload_a_group_avatar")
              %a.choose-btn.btn.btn-small.js-choose-group-avatar-button
                %i.icon-paper-clip
                %span= t("groups.choose_file")
              &nbsp;
              %span.file_name.js-avatar-filename= t("groups.file_name")
              = f.file_field :avatar, class: "js-group-avatar-input hidden"
              .light= t("groups.the_maximum_file_size")
              - if @group.avatar?
                %hr
                = link_to t("groups.g_remove_avatar"), group_avatar_path(@group.to_param), data: { confirm: t("groups.group_avatar_will_be_removed")}, method: :delete, class: "btn btn-remove btn-small remove-avatar"

          .form-actions
            = f.submit t("groups.save_group"), class: "btn btn-save"

    .panel.panel-danger
      .panel-heading= t("groups.remove_group")
      .panel-body
        %p
          = t("groups.removing_group_will_cause")
          %br
          %strong= t("groups.removed_group_cannot_be_restored")

        = link_to t("groups.remove_group"), @group, data: {confirm: t("groups.removed_group_cannot_be_restored_q")}, method: :delete, class: "btn btn-remove"

app/views/groups/issues.html.haml
%h3.page-title
  = t("groups.issues")
  %span.pull-right= t('groups.g_issues', count: @issues.total_count)

%p.light
  = t("groups.only_issues_from")
  %strong #{@group.name}
  = t("groups.group_are_listed_here")
  - if current_user
    = t('groups.to_see_all_issues')
    = link_to 'dashboard', issues_dashboard_path
    = t('groups.page') + "."
%hr

.row
  .fixed.sidebar-expand-button.hidden-lg.hidden-md
    %i.icon-list.icon-2x
  .col-md-3.responsive-side
    = render 'shared/filter', entity: 'issue'
  .col-md-9
    = render 'shared/issues'

app/views/groups/members.html.haml
- show_roles = should_user_see_group_roles?(current_user, @group)
%h3.page-title
  = t("groups.group_members")
- if show_roles
  %p.light
    = t("groups.members_of_group_have_access")
    = t("groups.read_more_about_permissions")
    %strong= link_to t("groups.here"), help_page_path("permissions", "permissions"), class: "vlink"

%hr

.clearfix.js-toggle-container
  = form_tag members_group_path(@group), method: :get, class: 'form-inline member-search-form'  do
    .form-group
      = search_field_tag :search, params[:search], { placeholder: t("groups.find_existin_member_by_name"), class: 'form-control search-text-input input-mn-300' }
    = submit_tag t("groups.search"), class: 'btn'

  - if current_user && current_user.can?(:manage_group, @group)
    .pull-right
      = link_to '#', class: 'btn btn-new js-toggle-button' do
        = t("groups.add_members")
        %i.icon-chevron-down

    .js-toggle-content.hide.new-group-member-holder
      = render "new_group_member"

.panel.panel-default.prepend-top-20
  .panel-heading
    %strong #{@group.name}
    = t("groups.group_members_small")
    %small
      (#{@members.total_count})
  %ul.well-list
    - @members.each do |member|
      = render 'users_groups/users_group', member: member, show_roles: show_roles, show_controls: true
= paginate @members, theme: 'gitlab'

:coffeescript
  $('form.member-search-form').on 'submit', (event) ->
    event.preventDefault()
    Turbolinks.visit @.action + '?' + $(@).serialize()

app/views/groups/merge_requests.html.haml
%h3.page-title
  = t("groups.merge_requests")
  %span.pull-right= t('groups.g_merge_requests', count: @merge_requests.total_count).downcase

%p.light
  = t("groups.only_merge_requests_from")
  %strong #{@group.name}
  = t("groups.group_are_listed_here")
  - if current_user
    = t('groups.to_see_all_merge_requests')
    = link_to('dashboard', merge_requests_dashboard_path)
    = t('groups.page') + "."
%hr
.row
  .fixed.sidebar-expand-button.hidden-lg.hidden-md
    %i.icon-list.icon-2x
  .col-md-3.responsive-side
    = render 'shared/filter', entity: 'merge_request'
  .col-md-9
    = render 'shared/merge_requests'

app/views/groups/new.html.haml
= form_for @group, html: { class: 'group-form form-horizontal' } do |f|
  - if @group.errors.any?
    .alert.alert-danger
      %span= @group.errors.full_messages.first
  .form-group
    = f.label :name, class: 'control-label' do
      = t("groups.group_name")
    .col-sm-10
      = f.text_field :name, placeholder: t("groups.ex_opensource"), class: "form-control"

  .form-group.group-description-holder
    = f.label :description, t("groups.details"), class: 'control-label'
    .col-sm-10
      = f.text_area :description, maxlength: 250, class: "form-control js-gfm-input", rows: 4

  .form-group.group-description-holder
    = f.label :avatar, t("groups.group_avatar"), class: 'control-label'
    .col-sm-10
      %a.choose-btn.btn.btn-small.js-choose-group-avatar-button
        %i.icon-paper-clip
        %span= t("groups.choose_file")
      &nbsp;
      %span.file_name.js-avatar-filename= t("groups.file_name")
      = f.file_field :avatar, class: "js-group-avatar-input hidden"
      .light= t("groups.the_maximum_file_size")

  .form-group
    .col-sm-2
    .col-sm-10
      %ul
        %li= t("groups.a_group_is_a_collection")
        %li= t("groups.groups_are_private")
        %li= t("groups.members_of_a_group_may_only_view_projects")
        %li= t("groups.group_project_urls")
        %li= t("groups.existing_projects_may_be_moved")

  .form-actions
    = f.submit t("groups.create_group"), class: "btn btn-create"

app/views/groups/projects.html.haml
.row
  .col-md-2
    = render 'settings_nav'
  .col-md-10
    .panel.panel-default
      .panel-heading
        %strong= @group.name
        = t('groups.projects').downcase
        - if can? current_user, :manage_group, @group
          .panel-head-actions
            = link_to new_project_path(namespace_id: @group.id), class: "btn btn-new" do
              %i.icon-plus
              = t("groups.new_project")
      %ul.well-list
        - @projects.each do |project|
          %li
            .list-item-name
              = visibility_level_icon(project.visibility_level)
              %strong= link_to project.name_with_namespace, project
              %span.label.label-gray
                = repository_size(project)
            .pull-right
              = link_to t("groups.members"), project_team_index_path(project), id: "edit_#{dom_id(project)}", class: "btn btn-small"
              = link_to t("groups.g_project_edit"), edit_project_path(project), id: "edit_#{dom_id(project)}", class: "btn btn-small"
              = link_to t("groups.remove"), project, data: { confirm: remove_project_message(project)}, method: :delete, class: "btn btn-small btn-remove"
        - if @projects.blank?
          .nothing-here-block= t("groups.this_group_has_no_projects")

    = paginate @projects, theme: "gitlab"

app/views/groups/show.html.haml
.dashboard
  .activities.col-md-8.hidden-sm.hidden-xs
    - if current_user
      = render "events/event_last_push", event: @last_push
      = link_to dashboard_path, class: 'btn btn-tiny' do
        &larr;
        = t("groups.to_dashboard")
      &nbsp;
    %span.cgray
      = t("groups.currently_you_are_only_seeing_events")
      = @group.name
      = t("groups.group_f")
    %hr
    = render 'shared/event_filter'
    - if @events.any?
      .content_list
    - else
      .nothing-here-block= t("groups.project_activity")
    = spinner
  .side.col-md-4
    .light-well.append-bottom-20
      = image_tag group_icon(@group.path), class: "avatar s90"
      .clearfix.light
        %h3.page-title
          = @group.name
        - if @group.description.present?
          %p
            = auto_link @group.description, link: :urls
    = render "projects", projects: @projects
    - if current_user
      .prepend-top-20
        = link_to group_path(@group, { format: :atom, private_token: current_user.private_token }), title: "Feed" do
          %strong
            %i.icon-rss
            = t("groups.news_feed")

    %hr
    = render 'shared/promo'